class Fl_Delta_Roller: public Fl_Roller {
	double delta_;
	int handle(int event);
	void handle_push() { delta_ = 0; Fl_Valuator::handle_push();}
	FL_EXPORT void handle_drag(double newvalue) {
		delta_ = newvalue - value();
		Fl_Valuator::handle_drag(newvalue);
	}

public:
	Fl_Delta_Roller(int x, int y, int w, int h, char* l=NULL): Fl_Roller(x, y, w, h, l) {}
	double delta() { return delta_; }
};

// Clipped from Fl_Roller source
int Fl_Delta_Roller::handle(int event) {
  static int ipos;
  int newpos = horizontal() ? Fl::event_x() : Fl::event_y();
  switch (event) {
  case FL_PUSH:
    handle_push();
    ipos = newpos;
    return 1;
  case FL_DRAG:
    // next line slightly edited...
    handle_drag(round(increment(previous_value(),newpos-ipos)));
   return 1;
  case FL_RELEASE:
    handle_release();
    return 1;
  default:
    return 0;
  }
}